<script setup lang="tsx">
import { reactive, ref, unref } from 'vue'
import {
  getSrdbKxqRuleListApi,
  saveSrdbKxqRuleApi,
  delSrdbKxqRuleListApi,
  delSrdbKxqRuleApi,
  querySrdbKxqRuleApi,
  exportExcelApi,
  importExcelApiUrl
} from '@/api/srdb/SrdbKxqRule'
import { Upload } from '@/components/Upload'
import { TableData } from '@/api/role/types'
import { useTable } from '@/hooks/web/useTable'
import { useI18n } from '@/hooks/web/useI18n'
import { Table, TableColumn } from '@/components/Table'
import { ElButton, ElLink, ElLoading, ElPopconfirm, ElMessage } from 'element-plus'
import { Search } from '@/components/Search'
import { FormSchema } from '@/components/Form'
import { ContentWrap } from '@/components/ContentWrap'
import Write from './components/Write.vue'
import Detail from './components/Detail.vue'
import { Dialog } from '@/components/Dialog'

const { t } = useI18n()

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getSrdbKxqRuleListApi({
      pageNum: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.body.list,
      total: res.body.total
    }
  },
  fetchDelApi: async () => {
    const res = await delSrdbKxqRuleListApi(unref(ids))
    return !!res
  }
})

const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const tableColumns = reactive<TableColumn[]>([
  {
    field: 'selection',
    type: 'selection'
  },
  {
    field: 'ruleCode',
    label: '规则编码'
  },
  {
    field: 'reportCode',
    label: '表编号'
  },
  {
    field: 'reportName',
    label: '表名'
  },
  {
    field: 'targetCol',
    label: '数据项编码'
  },
  {
    field: 'targetName',
    label: '数据项名称'
  },
  {
    field: 'bigtype',
    label: '大类'
  },
  {
    field: 'subtypes',
    label: '小类'
  },
  {
    field: 'ranges',
    label: '范围'
  },
  {
    field: 'formulaDescription',
    label: '公式说明'
  },
  {
    field: 'nature',
    label: '性质'
  },
  {
    field: 'dayThreshold',
    label: '缺失率阈值(单日）',
    hidden: true
  },
  {
    field: 'rollingThreshold',
    label: '缺失率阈值(滚动1个月平均）',
    hidden: true
  },
  {
    field: 'ruleSql',
    label: '规则SQL',
    hidden: true
  },
  {
    field: 'organId',
    label: '规则所属机构',
    hidden: true
  },
  {
    field: 'ruleStatus',
    label: '启停状态',
    hidden: true
  },
  {
    field: 'sparefield1',
    label: '备用1',
    hidden: true
  },
  {
    field: 'sparefield2',
    label: '备用2',
    hidden: true
  },
  {
    field: 'sparefield3',
    label: '备用3',
    hidden: true
  },
  {
    field: 'action',
    label: t('tableDemo.action'),
    width: 160,
    slots: {
      default: (data: any) => {
        return (
          <>
            <ElLink type="primary" underline={false} onClick={() => action(data.row, 'edit')}>
              {t('tableDemo.edit')}
            </ElLink>
            <ElPopconfirm
              title={t('common.delTableMsg')}
              width={200}
              v-slots={{
                reference: () => {
                  return (
                    <>
                      <ElLink type="primary" underline={false}>
                        {t('tableDemo.del')}
                      </ElLink>
                    </>
                  )
                }
              }}
              onConfirm={() => delData(data.row)}
            ></ElPopconfirm>
            <ElLink type="primary" underline={false} onClick={() => action(data.row, 'detail')}>
              {t('tableDemo.detail')}
            </ElLink>
          </>
        )
      }
    }
  }
])

const searchSchema = reactive<FormSchema[]>([
  {
    field: 'ruleCode',
    label: '规则编码',
    component: 'Input'
  },
  {
    field: 'reportCode',
    label: '表编号',
    component: 'Input'
  },
  {
    field: 'reportName',
    label: '表名',
    component: 'Input'
  },
  {
    field: 'targetCol',
    label: '数据项编码',
    component: 'Input'
  },
  {
    field: 'targetName',
    label: '数据项名称',
    component: 'Input'
  },
  {
    field: 'bigtype',
    label: '大类',
    component: 'Input'
  },
  {
    field: 'subtypes',
    label: '小类',
    component: 'Input'
  }
])

const searchParams = ref({})
const setSearchParams = (data: any) => {
  searchParams.value = data
  getList()
}

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref()
const actionType = ref('')

const writeRef = ref<ComponentRef<typeof Write>>()

/**单行查询**/
const action = async (row: any, type: string) => {
  let detailLoading = ElLoading.service({
    background: 'rgba(0, 0, 0, 0.7)'
  })
  const res = await querySrdbKxqRuleApi(row.ruleCode)
    .catch(() => {})
    .finally(() => {
      detailLoading.close()
    })
  detailLoading.close()
  if (res) {
    const data = res.body.result
    dialogTitle.value = t(type === 'edit' ? 'tableDemo.edit' : 'tableDemo.detail')
    actionType.value = type
    currentRow.value = data
    dialogVisible.value = true
  }
}

const AddAction = () => {
  dialogTitle.value = t('tableDemo.add')
  currentRow.value = undefined
  dialogVisible.value = true
  actionType.value = ''
}

const saveLoading = ref(false)

/** 保存 **/
const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveSrdbKxqRuleApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const delLoading = ref(false)

/** 批量删除  **/
const delDataBatch = async () => {
  const elTableExpose = await getElTableExpose()
  ids.value = elTableExpose?.getSelectionRows().map((v: TableData) => v.ruleCode) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

/** 单行删除 */
const delData = async (row: TableData) => {
  const res = await delSrdbKxqRuleApi(row.ruleCode)
  if (res) {
    const { code, errMsg } = res.head
    if (code === '0') {
      ElMessage.success('删除成功!')
      getList()
    } else {
      ElMessage.error(errMsg || '删除失败!')
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}

/** 导出Excel */
const exportExcel = async () => {
  const data = { ...unref(searchParams) }
  await exportExcelApi(data)
}
</script>

<template>
  <ContentWrap>
    <Search :schema="searchSchema" @reset="setSearchParams" @search="setSearchParams" />

    <Table
      :columns="tableColumns"
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      default-expand-all
      node-key="id"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total
      }"
      @selection-change="onSelectionChange"
      @register="tableRegister"
      @refresh="refresh"
    >
      <template #buttons>
        <ElButton type="primary" @click="AddAction">{{ t('tableDemo.add') }}</ElButton>
        <Upload :url="importExcelApiUrl" :callback="getList">
          <ElButton type="primary">导入</ElButton>
        </Upload>
        <ElButton type="primary" @click="exportExcel()">导出</ElButton>
        <ElButton :loading="delLoading" type="primary" :disabled="disabled" @click="delDataBatch()">
          {{ t('tableDemo.del') }}
        </ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write v-if="actionType !== 'detail'" ref="writeRef" :current-row="currentRow" />
    <Detail v-if="actionType === 'detail'" :current-row="currentRow" />
    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('dialogDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>
